// CodeGear C++Builder
// Copyright (c) 1995, 2009 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Vg_treeview.pas' rev: 21.00

#ifndef Vg_treeviewHPP
#define Vg_treeviewHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Menus.hpp>	// Pascal unit
#include <Clipbrd.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <Vg_scene.hpp>	// Pascal unit
#include <Vg_objects.hpp>	// Pascal unit
#include <Vg_layouts.hpp>	// Pascal unit
#include <Vg_listbox.hpp>	// Pascal unit
#include <Vg_controls.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Vg_treeview
{
//-- type declarations -------------------------------------------------------
class DELPHICLASS TvgTreeViewItem;
class DELPHICLASS TvgTreeView;
class PASCALIMPLEMENTATION TvgTreeViewItem : public Vg_controls::TvgTextControl
{
	typedef Vg_controls::TvgTextControl inherited;
	
private:
	bool FIsExpanded;
	Vg_controls::TvgCustomButton* FButton;
	Vg_controls::TvgCheckBox* FCheck;
	int FGlobalIndex;
	bool FIsChecked;
	bool FIsSelected;
	void __fastcall SetIsExpanded(const bool Value);
	void __fastcall DoButtonClick(System::TObject* Sender);
	void __fastcall DoCheckClick(System::TObject* Sender);
	int __fastcall GetCount(void);
	void __fastcall SetIsChecked(const bool Value);
	void __fastcall UpdateCheck(void);
	TvgTreeViewItem* __fastcall GetItem(int Index);
	void __fastcall SetIsSelected(const bool Value);
	
protected:
	virtual void __fastcall DesignClick(void);
	virtual void __fastcall ApplyStyle(void);
	virtual void __fastcall FreeStyle(void);
	virtual void __fastcall Realign(void);
	virtual void __fastcall DragEnd(void);
	virtual bool __fastcall EnterFocusChildren(Vg_scene::TvgVisualObject* AObject);
	
public:
	__fastcall virtual TvgTreeViewItem(Classes::TComponent* AOwner);
	virtual void __fastcall Paint(void);
	virtual void __fastcall AddObject(Vg_scene::TvgObject* AObject);
	virtual void __fastcall RemoveObject(Vg_scene::TvgObject* AObject);
	virtual System::UnicodeString __fastcall ItemClass(void);
	TvgTreeViewItem* __fastcall ItemByPoint(const float X, const float Y);
	TvgTreeViewItem* __fastcall ItemByIndex(const int Idx);
	__property int Count = {read=GetCount, nodefault};
	__property int GlobalIndex = {read=FGlobalIndex, write=FGlobalIndex, nodefault};
	TvgTreeView* __fastcall TreeView(void);
	int __fastcall Level(void);
	__property TvgTreeViewItem* Items[int Index] = {read=GetItem};
	
__published:
	__property bool IsChecked = {read=FIsChecked, write=SetIsChecked, nodefault};
	__property bool IsExpanded = {read=FIsExpanded, write=SetIsExpanded, nodefault};
	__property bool IsSelected = {read=FIsSelected, write=SetIsSelected, nodefault};
	__property AutoTranslate = {default=1};
	__property Font;
	__property Resource;
	__property Text;
	__property TextAlign = {default=1};
public:
	/* TvgTextControl.Destroy */ inline __fastcall virtual ~TvgTreeViewItem(void) { }
	
};


typedef int __fastcall (__closure *TOnCompareTreeViewItemEvent)(TvgTreeViewItem* Item1, TvgTreeViewItem* Item2);

typedef void __fastcall (__closure *TOnTreeViewDragChange)(TvgTreeViewItem* SourceItem, TvgTreeViewItem* DestItem, bool Allow);

class PASCALIMPLEMENTATION TvgTreeView : public Vg_layouts::TvgScrollBox
{
	typedef Vg_layouts::TvgScrollBox inherited;
	
private:
	bool FMouseSelecting;
	Classes::TNotifyEvent FOnChange;
	TvgTreeViewItem* FSelected;
	float FItemHeight;
	int FCountExpanded;
	bool FHideSelectionUnfocused;
	int FGlobalCount;
	bool FShowCheckboxes;
	Classes::TNotifyEvent FOnChangeCheck;
	bool FSorted;
	TOnCompareTreeViewItemEvent FOnCompare;
	bool FMultiSelect;
	TvgTreeViewItem* FFirstSelect;
	Vg_scene::TvgVisualObject* FSelection;
	Classes::TList* FSelections;
	bool FAllowDrag;
	TvgTreeViewItem* FDragItem;
	TOnTreeViewDragChange FOnDragChange;
	Classes::TList* FGlobalList;
	void __fastcall SetItemHeight(const float Value);
	void __fastcall SetShowCheckboxes(const bool Value);
	TvgTreeViewItem* __fastcall GetItem(int Index);
	void __fastcall SetSorted(const bool Value);
	void __fastcall SortItems(void);
	Vg_controls::TvgSelectionItem* __fastcall GetSelection(void);
	void __fastcall ClearSelection(void);
	void __fastcall SelectAll(void);
	void __fastcall SelectRange(TvgTreeViewItem* Item1, TvgTreeViewItem* Item2);
	void __fastcall UpdateSelection(void);
	void __fastcall SetAllowDrag(const bool Value);
	int __fastcall GetCount(void);
	
protected:
	virtual void __fastcall Notification(Classes::TComponent* AComponent, Classes::TOperation Operation);
	virtual void __fastcall SetSelected(const TvgTreeViewItem* Value);
	virtual void __fastcall ApplyStyle(void);
	virtual void __fastcall FreeStyle(void);
	virtual void __fastcall EnterFocus(void);
	virtual void __fastcall KillFocus(void);
	virtual void __fastcall HScrollChange(System::TObject* Sender);
	virtual void __fastcall VScrollChange(System::TObject* Sender);
	virtual Vg_scene::TvgRect __fastcall GetContentBounds(void);
	void __fastcall UpdateGlobalIndexes(void);
	virtual void __fastcall ContentAddObject(Vg_scene::TvgObject* AObject);
	virtual void __fastcall ContentRemoveObject(Vg_scene::TvgObject* AObject);
	Vg_scene::TvgRect __fastcall GetItemRect(TvgTreeViewItem* Item);
	
public:
	__fastcall virtual TvgTreeView(Classes::TComponent* AOwner);
	__fastcall virtual ~TvgTreeView(void);
	virtual System::UnicodeString __fastcall ItemClass(void);
	virtual void __fastcall EndUpdate(void);
	void __fastcall Clear(void);
	void __fastcall ExpandAll(void);
	void __fastcall CollapseAll(void);
	TvgTreeViewItem* __fastcall ItemByPoint(const float X, const float Y);
	TvgTreeViewItem* __fastcall ItemByIndex(const int Idx);
	TvgTreeViewItem* __fastcall ItemByGlobalIndex(const int Idx);
	virtual void __fastcall AddObject(Vg_scene::TvgObject* AObject);
	virtual void __fastcall MouseDown(Controls::TMouseButton Button, Classes::TShiftState Shift, float X, float Y);
	virtual void __fastcall MouseMove(Classes::TShiftState Shift, float X, float Y, float Dx, float Dy);
	virtual void __fastcall MouseUp(Controls::TMouseButton Button, Classes::TShiftState Shift, float X, float Y);
	virtual void __fastcall KeyDown(System::Word &Key, System::WideChar &KeyChar, Classes::TShiftState Shift);
	virtual void __fastcall KeyUp(System::Word &Key, System::WideChar &KeyChar, Classes::TShiftState Shift);
	virtual void __fastcall DragOver(const Vg_scene::TvgDragObject &Data, const Vg_scene::TvgPoint &Point, bool &Accept);
	virtual void __fastcall DragDrop(const Vg_scene::TvgDragObject &Data, const Vg_scene::TvgPoint &Point);
	__property int Count = {read=GetCount, nodefault};
	__property int GlobalCount = {read=FGlobalCount, nodefault};
	__property int CountExpanded = {read=FCountExpanded, nodefault};
	__property TvgTreeViewItem* Selected = {read=FSelected, write=SetSelected};
	__property TvgTreeViewItem* Items[int Index] = {read=GetItem};
	
__published:
	__property Resource;
	__property CanFocused = {default=1};
	__property DisableFocusEffect = {default=0};
	__property TabOrder = {default=-1};
	__property bool AllowDrag = {read=FAllowDrag, write=SetAllowDrag, default=0};
	__property float ItemHeight = {read=FItemHeight, write=SetItemHeight};
	__property bool HideSelectionUnfocused = {read=FHideSelectionUnfocused, write=FHideSelectionUnfocused, default=1};
	__property bool MultiSelect = {read=FMultiSelect, write=FMultiSelect, default=0};
	__property bool ShowCheckboxes = {read=FShowCheckboxes, write=SetShowCheckboxes, default=0};
	__property bool Sorted = {read=FSorted, write=SetSorted, default=0};
	__property Classes::TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
	__property Classes::TNotifyEvent OnChangeCheck = {read=FOnChangeCheck, write=FOnChangeCheck};
	__property TOnCompareTreeViewItemEvent OnCompare = {read=FOnCompare, write=FOnCompare};
	__property TOnTreeViewDragChange OnDragChange = {read=FOnDragChange, write=FOnDragChange};
};


//-- var, const, procedure ---------------------------------------------------

}	/* namespace Vg_treeview */
using namespace Vg_treeview;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Vg_treeviewHPP
